## lfortran 0.30.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_SOURCE_DIR}/cmake/UserOverride.cmake)

# We don't execute this if we have a tarball
if (LFORTRAN_BUILD_ALL)
    find_program(BASH_BIN bash)
    execute_process(COMMAND "${BASH_BIN}" "-e" "build0.sh" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE _BUILD0_EXIT)
    if (NOT _BUILD0_EXIT EQUAL 0)
        message(FATAL_ERROR "Running build0.sh failed (see error above)")
    endif ()
endif()

file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/version" LFORTRAN_VERSION)
string(REGEX MATCH "^[^-]*" LFORTRAN_NO_TAG_VERSION ${LFORTRAN_VERSION})

project(lfortran
        VERSION ${LFORTRAN_NO_TAG_VERSION}
        DESCRIPTION "A modern open-source interactive Fortran compiler"
        HOMEPAGE_URL "https://lfortran.org/"
        LANGUAGES C CXX)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release
        CACHE STRING "Build type (Debug, Release)" FORCE)
endif ()

# xeus does use `dynamic_cast` and thus needs rtti (otherwise it segfaults)
if (NOT WITH_XEUS)
    if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set(LFORTRAN_CXX_NO_RTTI_FLAG "-fno-rtti")
    elseif (CMAKE_CXX_COMPILER_ID MATCHES Clang)
        set(LFORTRAN_CXX_NO_RTTI_FLAG "-fno-rtti")
    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        set(LFORTRAN_CXX_NO_RTTI_FLAG "/GR-")
    endif ()
endif(NOT WITH_XEUS)

# For CMAKE_INSTALL_BINDIR:
include(GNUInstallDirs)

# create CMAKE_INSTALL_LIBDIR_RELATIVE, LIBDIR relative to BINDIR
file(RELATIVE_PATH CMAKE_INSTALL_LIBDIR_RELATIVE ${CMAKE_INSTALL_FULL_BINDIR} ${CMAKE_INSTALL_FULL_LIBDIR})
# create CMAKE_INSTALL_INCLUDEDIR_RELATIVE, INCLUDEDIR relative to BINDIR
file(RELATIVE_PATH CMAKE_INSTALL_INCLUDEDIR_RELATIVE ${CMAKE_INSTALL_FULL_BINDIR} ${CMAKE_INSTALL_FULL_INCLUDEDIR})

# Build a CPack driven installer package
#
# To build a binary package:
#
# cpack
#
include(InstallRequiredSystemLibraries)
set(CPACK_GENERATOR "TBZ2")
set(CPACK_STRIP_FILES YES)
set(CPACK_PACKAGE_FILE_NAME lfortran-${LFORTRAN_VERSION}-${CMAKE_SYSTEM_NAME})
include(CPack)
# So that CPACK_PACKAGE_FILE_NAME prints the correct value below
set(CPACK_PACKAGE_FILE_NAME lfortran-${LFORTRAN_VERSION}-${CMAKE_SYSTEM_NAME})


if (NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17
        CACHE STRING "C++ standard" FORCE)
endif ()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # In Debug mode we enable assertions
    set(WITH_LFORTRAN_ASSERT_DEFAULT yes)
else()
    set(WITH_LFORTRAN_ASSERT_DEFAULT no)
endif()


# LFORTRAN_ASSERT
set(WITH_LFORTRAN_ASSERT ${WITH_LFORTRAN_ASSERT_DEFAULT}
    CACHE BOOL "Enable LFORTRAN_ASSERT macro")

# LFORTRAN_STATIC_BIN
set(LFORTRAN_STATIC_BIN no CACHE BOOL "Build LFortran as a static binary")

# WITH_LFORTRAN_BINARY_MODFILES
set(WITH_LFORTRAN_BINARY_MODFILES YES
    CACHE BOOL "Use binary modfiles")

set(WITH_RUNTIME_LIBRARY YES
    CACHE BOOL "Compile and install the runtime library")

set(WITH_WHEREAMI yes
    CACHE BOOL "Include whereami.cpp")

set(WITH_ZLIB yes
    CACHE BOOL "Compile with ZLIB Library")

set(WITH_LCOMPILERS_FAST_ALLOC yes
    CACHE BOOL "Compile with fast allocator")

# Build to wasm
set(LFORTRAN_BUILD_TO_WASM no
    CACHE BOOL "Compile LFortran To WASM")

if (LFORTRAN_BUILD_TO_WASM)
    set(HAVE_BUILD_TO_WASM yes)
    SET(WITH_WHEREAMI no)
    SET(WITH_ZLIB no)
    SET(WITH_RUNTIME_LIBRARY no)
    SET(WITH_LCOMPILERS_FAST_ALLOC no)
    add_definitions("-DHAVE_BUILD_TO_WASM=1")
endif()

if (WITH_WHEREAMI)
    add_definitions("-DHAVE_WHEREAMI=1")
endif()

if (WITH_ZLIB)
    add_definitions("-DHAVE_ZLIB=1")

    # Find ZLIB with our custom finder before including LLVM since the finder for LLVM
    # might search for ZLIB again and find the shared libraries instead of the static ones
    find_package(StaticZLIB REQUIRED)
endif()

if (WITH_LCOMPILERS_FAST_ALLOC)
    add_definitions("-DLCOMPILERS_FAST_ALLOC=1")
endif()


# LLVM
set(WITH_LLVM no CACHE BOOL "Build with LLVM support")
set(WITH_TARGET_AARCH64 no CACHE BOOL "Enable target AARCH64")
set(WITH_TARGET_X86 no CACHE BOOL "Enable target X86")
set(WITH_TARGET_WASM no CACHE BOOL "Enable target WebAssembly")
if (WITH_LLVM)
    find_package(StaticZSTD REQUIRED)

    set(LFORTRAN_LLVM_COMPONENTS core support mcjit orcjit native asmparser asmprinter)
    find_package(LLVM REQUIRED)
    message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
    message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")

    # Always enable the native target
    if ("${LLVM_NATIVE_ARCH}" STREQUAL "AArch64")
        set(WITH_TARGET_AARCH64 yes)
    endif()

    if ("${LLVM_NATIVE_ARCH}" STREQUAL "X86")
        set(WITH_TARGET_X86 yes)
    endif()

    if (WITH_TARGET_AARCH64)
        if (NOT ("${LLVM_TARGETS_TO_BUILD}" MATCHES "AArch64"))
            message(FATAL_ERROR "The selected LLVM library doesn't have support for AArch64 targets")
        endif()

        list(APPEND LFORTRAN_LLVM_COMPONENTS aarch64info aarch64utils aarch64desc aarch64asmparser aarch64codegen aarch64disassembler)
        add_definitions("-DHAVE_TARGET_AARCH64=1")
    endif()

    if (WITH_TARGET_X86)
        if (NOT ("${LLVM_TARGETS_TO_BUILD}" MATCHES "X86"))
            message(FATAL_ERROR "The selected LLVM library doesn't have support for X86 targets")
        endif()

        list(APPEND LFORTRAN_LLVM_COMPONENTS x86info x86desc x86codegen x86asmparser x86disassembler)
        add_definitions("-DHAVE_TARGET_X86=1")
    endif()

    if (WITH_TARGET_WASM)
        if (NOT ("${LLVM_TARGETS_TO_BUILD}" MATCHES "WebAssembly"))
            message(FATAL_ERROR "The selected LLVM library doesn't have support for WebAssembly targets")
        endif()

        list(APPEND LFORTRAN_LLVM_COMPONENTS webassemblyasmparser webassemblycodegen webassemblydesc webassemblydisassembler webassemblyinfo)
        add_definitions("-DHAVE_TARGET_WASM=1")
    endif()

    if (TARGET LLVMCore)
        # If `LLVMCore` target is present, then LLVM is distributed as separate
        # libraries and llvm_map_components_to_libnames() should work:
        llvm_map_components_to_libnames(llvm_libs ${LFORTRAN_LLVM_COMPONENTS})
    else()
        # Workaround for https://github.com/llvm/llvm-project/issues/34593
        # If LLVM is distributed as a single library (the LLVMCore target is
        # missing), we set `llvm_libs` to "LLVM" which links against the single
        # `libLLVM.so` shared library.
        set(llvm_libs "LLVM")
    endif()
    unset(LFORTRAN_LLVM_COMPONENTS)

    add_library(p::llvm INTERFACE IMPORTED)
    set_property(TARGET p::llvm PROPERTY INTERFACE_INCLUDE_DIRECTORIES
        ${LLVM_INCLUDE_DIRS})
    #set_property(TARGET p::llvm PROPERTY INTERFACE_COMPILE_DEFINITIONS
    #    ${LLVM_DEFINITIONS})
    #set_property(TARGET p::llvm PROPERTY INTERFACE_COMPILE_OPTIONS
    #    ${LLVM_DEFINITIONS})
    set_property(TARGET p::llvm PROPERTY INTERFACE_COMPILE_OPTIONS
        $<$<COMPILE_LANGUAGE:CXX>:${LFORTRAN_CXX_NO_RTTI_FLAG}>)
    set_property(TARGET p::llvm PROPERTY INTERFACE_LINK_LIBRARIES
        ${llvm_libs})
    if (MSVC)
        # LLVM on Windows appends zlib shared library and we must provide
        # a path to find it:
        get_filename_component(mypath ${ZLIB_LIBRARY} DIRECTORY)
        target_link_directories(p::llvm BEFORE INTERFACE ${mypath})
        message(STATUS "ZLIB LIBRARY PATH: ${mypath}")
    endif()
    set(HAVE_LFORTRAN_LLVM yes)
endif()

# XEUS (Fortran kernel)
set(WITH_XEUS no CACHE BOOL "Build with XEUS support")
if (WITH_XEUS)
    find_package(xeus 3.0.5 REQUIRED)
    find_package(xeus-zmq 1.0.2 REQUIRED)
    set(HAVE_LFORTRAN_XEUS yes)

    # Generate kernel.json with correct paths
    configure_file (
        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/fortran/kernel.json.in"
        "${CMAKE_CURRENT_BINARY_DIR}/share/jupyter/kernels/fortran/kernel.json"
    )

    # Configuration and data directories for Jupyter and LFortran
    set(XJUPYTER_DATA_DIR "share/jupyter" CACHE STRING "Jupyter data directory")

    # Install Jupyter kernelspecs
    set(XEUS_CALCSPEC_DIR ${CMAKE_CURRENT_BINARY_DIR}/share/jupyter/kernels)
    install(DIRECTORY ${XEUS_CALCSPEC_DIR}
            DESTINATION ${XJUPYTER_DATA_DIR}
            PATTERN "*.in" EXCLUDE)
endif()

# JSON
set(WITH_JSON no CACHE BOOL "Build with JSON support")
if (WITH_JSON)
    find_package(RapidJSON REQUIRED)
endif()

set(HAVE_LFORTRAN_DEMANGLE yes
    CACHE BOOL "Build with C++ name demangling support (cxxabi.h)")

if (MSVC)
    # MSVC doesn't have cxxabi.h
    set(HAVE_LFORTRAN_DEMANGLE no)
endif()

# fmt (`conda install fmt`)
set(WITH_FMT no CACHE BOOL "Build with `fmt` support")
if (WITH_FMT)
    find_package(fmt)
endif()

# Stacktrace
set(WITH_UNWIND no
    CACHE BOOL "Build with unwind support")
set(WITH_BFD no
    CACHE BOOL "Build with BFD support")
set(WITH_DWARFDUMP no
    CACHE BOOL "Build with dwarfdump support")
set(WITH_LINKH no
    CACHE BOOL "Build with link.h support")
set(WITH_MACHO no
    CACHE BOOL "Build with mach-o support")
set(WITH_STACKTRACE no
    CACHE BOOL "Build with stacktrace support (requires binutils-dev)")
if (WITH_STACKTRACE)
    set(WITH_UNWIND yes)
    if (APPLE)
        set(WITH_MACHO yes)
        if (NOT WITH_BFD)
            set(WITH_DWARFDUMP yes)
        endif()
    else()
        set(WITH_LINKH yes)
        set(WITH_BFD yes)
    endif()
    set(HAVE_LFORTRAN_STACKTRACE yes)
endif()
if (WITH_RUNTIME_STACKTRACE)
    set(WITH_UNWIND yes)
    if (APPLE)
        set(WITH_MACHO yes)
    else()
        set(WITH_LINKH yes)
    endif()
    set(HAVE_RUNTIME_STACKTRACE yes)
endif()
if (WITH_BFD)
    find_package(BFD REQUIRED)
    set(HAVE_LFORTRAN_BFD yes)
endif()
if (WITH_DWARFDUMP)
    set(HAVE_LFORTRAN_DWARFDUMP yes)
endif()
if (WITH_LINKH)
    find_package(LINKH REQUIRED)
    set(HAVE_LFORTRAN_LINK yes)
endif()
if (WITH_MACHO)
    find_package(MACHO REQUIRED)
    set(HAVE_LFORTRAN_MACHO yes)
endif()
if (WITH_UNWIND)
    set(HAVE_LFORTRAN_UNWIND yes)
endif()

set(WITH_KOKKOS no CACHE BOOL "Detect Kokkos location for cpp backend")
if (WITH_KOKKOS)
   find_package(Kokkos)
   if(TARGET Kokkos::kokkoscore)
     get_target_property(KOKKOS_INCLUDEDIR Kokkos::kokkoscore INTERFACE_INCLUDE_DIRECTORIES)
     get_target_property(KOKKOS_LIBRARY Kokkos::kokkoscore LOCATION)
     get_filename_component(KOKKOS_LIBDIR "${KOKKOS_LIBRARY}" DIRECTORY)
   endif()
endif()

enable_testing()

message("\n")
message("Configuration results")
message("---------------------")
message("LFORTRAN_VERSION: ${LFORTRAN_VERSION}")
message("CPACK_PACKAGE_FILE_NAME: ${CPACK_PACKAGE_FILE_NAME}")
message("C compiler      : ${CMAKE_C_COMPILER}")
message("C++ compiler    : ${CMAKE_CXX_COMPILER}")
message("Build type: ${CMAKE_BUILD_TYPE}")
string(TOUPPER "${CMAKE_BUILD_TYPE}" BTYPE)
message("C compiler flags      : ${CMAKE_C_FLAGS_${BTYPE}}")
message("C++ compiler flags    : ${CMAKE_CXX_FLAGS_${BTYPE}}")
message("Installation prefix: ${CMAKE_INSTALL_PREFIX}")
message("WITH_LFORTRAN_ASSERT: ${WITH_LFORTRAN_ASSERT}")
message("LFORTRAN_STATIC_BIN: ${LFORTRAN_STATIC_BIN}")
message("LFORTRAN_BUILD_TO_WASM: ${LFORTRAN_BUILD_TO_WASM}")
message("WITH_STACKTRACE: ${WITH_STACKTRACE}")
message("WITH_RUNTIME_STACKTRACE: ${WITH_RUNTIME_STACKTRACE}")
message("WITH_UNWIND: ${WITH_UNWIND}")
message("WITH_BFD: ${WITH_BFD}")
message("WITH_DWARFDUMP: ${WITH_DWARFDUMP}")
message("WITH_LINKH: ${WITH_LINKH}")
message("WITH_MACHO: ${WITH_MACHO}")
message("HAVE_LFORTRAN_DEMANGLE: ${HAVE_LFORTRAN_DEMANGLE}")
message("WITH_LLVM: ${WITH_LLVM}")
message("WITH_XEUS: ${WITH_XEUS}")
message("WITH_JSON: ${WITH_JSON}")
message("WITH_FMT: ${WITH_FMT}")
message("WITH_LFORTRAN_BINARY_MODFILES: ${WITH_LFORTRAN_BINARY_MODFILES}")
message("WITH_RUNTIME_LIBRARY: ${WITH_RUNTIME_LIBRARY}")
message("WITH_WHEREAMI: ${WITH_WHEREAMI}")
message("WITH_ZLIB: ${WITH_ZLIB}")
message("WITH_TARGET_AARCH64: ${WITH_TARGET_AARCH64}")

=== src/bin/CMakeLists.txt ===
add_executable(lfortran lfortran.cpp)
target_include_directories(lfortran PRIVATE "tpl")
target_link_libraries(lfortran lfortran_lib)
if (LFORTRAN_STATIC_BIN)
    if (CMAKE_SYSTEM_NAME STREQUAL "Linux"
        OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD"
        OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")

        # Link statically on Linux with gcc or clang
        if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
                CMAKE_CXX_COMPILER_ID MATCHES Clang)
            target_link_options(lfortran PRIVATE -static)
        endif()
    endif()
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Linux"
    OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD"
    OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")

    target_link_options(lfortran PRIVATE "LINKER:--export-dynamic")
endif()

if (WITH_STACKTRACE AND APPLE AND CMAKE_CXX_COMPILER_ID MATCHES Clang)
    # On macOS we have to call dsymutil to create the dSYM bundle so that the
    # stacktrace can find debugging information corresponding to the lfortran
    # binary
    add_custom_command(
        TARGET lfortran
        POST_BUILD
        COMMAND dsymutil lfortran
    )
    if (WITH_DWARFDUMP)
        add_custom_command(
            TARGET lfortran
            POST_BUILD
            COMMAND llvm-dwarfdump --debug-line lfortran.dSYM > lfortran.dSYM/raw.txt
        )
        add_custom_command(
            TARGET lfortran
            POST_BUILD
            COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../libasr/dwarf_convert.py lfortran.dSYM/raw.txt lfortran.dSYM/lines.txt lfortran.dSYM/lines.dat
        )
    endif()
endif()

# Ensure "Release" is not appended to the path on Windows:
# https://stackoverflow.com/a/56201564/479532
set_target_properties(lfortran PROPERTIES RUNTIME_OUTPUT_DIRECTORY $<0:>)

set_target_properties(lfortran PROPERTIES
    INSTALL_RPATH_USE_LINK_PATH TRUE
)

if (HAVE_BUILD_TO_WASM)
    # "-g0": Store no debugging information in the generated wasm file. This helps reduce generated file size
    # "-Oz": Optimize for size. With this code size ~ 2.4mb. Without this code size ~49mb
    # "-fexceptions": Enable Cpp exception support
    # "--no-entry": No start function to execute
    # "-s ASSERTIONS": Compile with Assertions which (as per docs) are helpful to debug compilation process
    # "-s ALLOW_MEMORY_GROWTH": Allow dynamic memory growth upto the maximum page size limit
    # "-s WASM_BIGINT": Allow use of i64 integers. ASR is needing this option to be enabled.
    # "-s EXPORTED_RUNTIME_METHODS=['cwrap']": Export cwarp. cwarp helps us to call our EMSCRIPTEN_KEEPALIVE functions

    # Notes:
    # STANDALONE_WASM is disabling support for exceptions, so it is currently omitted
    # In build_to_wasm.sh, we need CMAKE_CXX_FLAGS_DEBUG="-Wall -Wextra -fexceptions" flags for exception support
    set(WASM_COMPILE_FLAGS "-g0 -fexceptions")
    set(WASM_LINK_FLAGS
      "-g0 -Oz -fexceptions --preload-file asset_dir -Wall -Wextra --no-entry -s ASSERTIONS -s ALLOW_MEMORY_GROWTH=1 -s WASM_BIGINT -s \"EXPORTED_RUNTIME_METHODS=['cwrap']\""
    )
    set_target_properties(lfortran PROPERTIES COMPILE_FLAGS ${WASM_COMPILE_FLAGS})
    set_target_properties(lfortran PROPERTIES LINK_FLAGS ${WASM_LINK_FLAGS})
endif()

install(TARGETS lfortran
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)


add_executable(parse parse.cpp)
target_link_libraries(parse lfortran_lib)

add_executable(parse2 parse2.cpp)
target_link_libraries(parse2 lfortran_lib)

if (WITH_FMT)
    add_executable(parse3 parse3.cpp)
    target_link_libraries(parse3 lfortran_lib fmt::fmt)
endif()

add_executable(cpptranslate cpptranslate.cpp)
target_link_libraries(cpptranslate lfortran_lib)

=== src/libasr/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(libasr)

if (NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17
        CACHE STRING "C++ standard" FORCE)
endif ()

if (NOT LFORTRAN_VERSION)
    set(LFORTRAN_VERSION "0.1-git"
        CACHE STRING "LFortran version" FORCE)
endif ()

configure_file(config.h.in config.h)

set(SRC
    codegen/asr_to_cpp.cpp
    codegen/asr_to_c.cpp
    codegen/asr_to_julia.cpp
    codegen/asr_to_fortran.cpp
    codegen/asr_to_py.cpp
    codegen/x86_assembler.cpp
    codegen/asr_to_x86.cpp
    codegen/asr_to_wasm.cpp
    codegen/wasm_to_wat.cpp
    codegen/wasm_to_x86.cpp
    codegen/wasm_to_x64.cpp
    codegen/wasm_utils.cpp

    pass/nested_vars.cpp
    pass/where.cpp
    pass/param_to_const.cpp
    pass/do_loops.cpp
    pass/for_all.cpp
    pass/global_stmts.cpp
    pass/select_case.cpp
    pass/init_expr.cpp
    pass/implied_do_loops.cpp
    pass/array_op.cpp
    pass/subroutine_from_function.cpp
    pass/transform_optional_argument_functions.cpp
    pass/class_constructor.cpp
    pass/arr_slice.cpp
    pass/print_arr.cpp
    pass/print_struct_type.cpp
    pass/print_list_tuple.cpp
    pass/pass_utils.cpp
    pass/unused_functions.cpp
    pass/flip_sign.cpp
    pass/div_to_mul.cpp
    pass/replace_symbolic.cpp
    pass/intrinsic_function.cpp
    pass/fma.cpp
    pass/loop_vectorise.cpp
    pass/sign_from_value.cpp
    pass/inline_function_calls.cpp
    pass/loop_unroll.cpp
    pass/dead_code_removal.cpp
    pass/instantiate_template.cpp
    pass/update_array_dim_intrinsic_calls.cpp
    pass/pass_array_by_data.cpp
    pass/pass_list_expr.cpp
    pass/pass_compare.cpp
    pass/unique_symbols.cpp
    pass/insert_deallocate.cpp
    pass/promote_allocatable_to_nonallocatable.cpp

    asr_verify.cpp
    asr_utils.cpp
    casting_utils.cpp
    diagnostics.cpp
    stacktrace.cpp
    string_utils.cpp
    asr_scopes.cpp
    modfile.cpp
    pickle.cpp
    serialization.cpp
    utils2.cpp
)
if (WITH_LLVM)
    set(SRC ${SRC}
        codegen/evaluator.cpp
        codegen/asr_to_llvm.cpp
        codegen/llvm_array_utils.cpp
        codegen/llvm_utils.cpp
    )
    # We use deprecated API in LLVM, so we disable the warning until we upgrade
    if (NOT MSVC)
        set_source_files_properties(codegen/evaluator.cpp PROPERTIES
            COMPILE_FLAGS -Wno-deprecated-declarations)
        set_source_files_properties(codegen/asr_to_llvm.cpp PROPERTIES
            COMPILE_FLAGS -Wno-deprecated-declarations)
        set_source_files_properties(codegen/llvm_array_utils.cpp PROPERTIES
            COMPILE_FLAGS -Wno-deprecated-declarations)
        set_source_files_properties(codegen/llvm_utils.cpp PROPERTIES
            COMPILE_FLAGS -Wno-deprecated-declarations)
    endif()
endif()
add_library(asr STATIC ${SRC})
target_include_directories(asr BEFORE PUBLIC ${libasr_SOURCE_DIR}/..)
target_include_directories(asr BEFORE PUBLIC ${libasr_BINARY_DIR}/..)
if (WITH_BFD)
    target_link_libraries(asr p::bfd)
endif()
if (WITH_LINK)
    target_link_libraries(asr p::link)
endif()
if (WITH_EXECINFO)
    target_link_libraries(asr p::execinfo)
endif()
if (WITH_LLVM)
    target_link_libraries(asr p::llvm)
endif()

=== src/runtime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(lfortran_unif_runtime C Fortran)

set(LFORTRAN_NESTED_BUILD no
    CACHE BOOL "Whether we are being called from the LFortran build system")

if(NOT LFORTRAN_NESTED_BUILD)
  add_subdirectory(legacy)
endif()

# See the TODO in the installation step below
set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR})
include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})

macro(lfortran_compile_runtime name dir)
  add_library(${name} OBJECT ${dir}/${name}.f90)
  target_compile_options(${name} PUBLIC "--backend=cpp")
  set_target_properties(${name} PROPERTIES
    POSITION_INDEPENDENT_CODE False
    Fortran_PREPROCESS False)

  if(ARGN)
    add_dependencies(${name} ${ARGN})
  endif()
endmacro(lfortran_compile_runtime)

lfortran_compile_runtime(lfortran_intrinsic_builtin builtin)
lfortran_compile_runtime(lfortran_intrinsic_kind pure)
lfortran_compile_runtime(lfortran_intrinsic_iso_fortran_env pure)

lfortran_compile_runtime(lfortran_intrinsic_custom custom)

lfortran_compile_runtime(lfortran_intrinsic_optimization builtin)
add_dependencies(lfortran_intrinsic_optimization lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_math3 pure)
add_dependencies(lfortran_intrinsic_math3 lfortran_intrinsic_iso_fortran_env)
add_dependencies(lfortran_intrinsic_math3 lfortran_intrinsic_builtin)

lfortran_compile_runtime(lfortran_intrinsic_math2 pure)
add_dependencies(lfortran_intrinsic_math2 lfortran_intrinsic_iso_fortran_env)
add_dependencies(lfortran_intrinsic_math2 lfortran_intrinsic_math3)
add_dependencies(lfortran_intrinsic_math2 lfortran_intrinsic_builtin)

lfortran_compile_runtime(lfortran_intrinsic_ieee_arithmetic pure)
add_dependencies(lfortran_intrinsic_ieee_arithmetic lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_iso_c_binding pure)
add_dependencies(lfortran_intrinsic_iso_c_binding lfortran_intrinsic_builtin)

lfortran_compile_runtime(lfortran_intrinsic_string pure)
add_dependencies(lfortran_intrinsic_string lfortran_intrinsic_builtin)
add_dependencies(lfortran_intrinsic_string lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_trig pure)
add_dependencies(lfortran_intrinsic_trig lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_math impure)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_iso_c_binding)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_builtin)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_iso_fortran_env)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_math2)

lfortran_compile_runtime(lfortran_intrinsic_sin impure)
add_dependencies(lfortran_intrinsic_sin lfortran_intrinsic_iso_c_binding)
add_dependencies(lfortran_intrinsic_sin lfortran_intrinsic_builtin)
add_dependencies(lfortran_intrinsic_sin lfortran_intrinsic_iso_fortran_env)
add_dependencies(lfortran_intrinsic_sin lfortran_intrinsic_math)

lfortran_compile_runtime(lfortran_intrinsic_bit impure)
add_dependencies(lfortran_intrinsic_bit lfortran_intrinsic_iso_fortran_env)

# Ideally this should be a target based install, not file based:
# install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/ DESTINATION ${CMAKE_INSTALL_LIBDIR})
# but for historical reasons get_runtime_library_dir() looks under "/../../runtime"
# during tests.
# TODO: Change get_runtime_library_dir() to "/../../modfiles" for tests
install(
  FILES
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_builtin.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_custom.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_optimization.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_kind.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_iso_fortran_env.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_ieee_arithmetic.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_iso_c_binding.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_math2.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_math3.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_math.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_trig.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_sin.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_string.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_bit.mod
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

=== src/runtime/builtin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(lfortran_runtime_builtin C Fortran)

add_library(lfortran_runtime_builtin
    STATIC
    lfortran_intrinsic_builtin.f90
    lfortran_intrinsic_optimization.f90
)

=== src/runtime/impure/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(lfortran_runtime_impure C Fortran)

add_library(lfortran_runtime_impure
    STATIC
    lfortran_intrinsics.c
    lfortran_intrinsic_math.f90
    lfortran_intrinsic_sin.f90
    lfortran_intrinsic_sin_c.c
    lfortran_intrinsic_bit.f90
)

=== src/runtime/legacy/CMakeLists.txt ===
set(SRC
    ../../../src/libasr/runtime/lfortran_intrinsics.c
)

add_library(lfortran_runtime SHARED ${SRC})
target_include_directories(lfortran_runtime BEFORE PUBLIC ${libasr_SOURCE_DIR}/..)
target_include_directories(lfortran_runtime BEFORE PUBLIC ${libasr_BINARY_DIR}/..)
set_target_properties(lfortran_runtime PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR})
set_target_properties(lfortran_runtime PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ..)

add_library(lfortran_runtime_static STATIC ${SRC})
target_include_directories(lfortran_runtime_static BEFORE PUBLIC ${libasr_SOURCE_DIR}/..)
target_include_directories(lfortran_runtime_static BEFORE PUBLIC ${libasr_BINARY_DIR}/..)
set_target_properties(lfortran_runtime_static PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ..)

install(TARGETS lfortran_runtime_static
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(TARGETS lfortran_runtime
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

# Install the header
install(
    FILES ../../../src/libasr/runtime/lfortran_intrinsics.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lfortran/impure
)

=== debian/changelog ===
lfortran (0.30.0-5) unstable; urgency=medium

  * autopkgtests need to dep on build-essential. Closes: #1062813, #1063056

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Feb 2024 17:55:26 +0000

lfortran (0.30.0-4) unstable; urgency=medium

  * Disable KOKKOS and cpp-backend test. Currently break the build.
    Closes: #1062813

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Feb 2024 16:13:58 +0000

lfortran (0.30.0-3) unstable; urgency=medium

  * Patch to ensure we use shared zstd lib, not static
  * Build-dep on pandoc for man page
  * Add lfortran.1 manpage
  * Add WITH_KOKKOS=yes for cpp backend
  * clang-16 needed for specified llvm backend
  * Add autopkgtests from  example files
  * Build-dep on xeus-dev, xeus-zmq-dev for Jupyter kernel support
  * Don't use shared bfd library. Closes: #1061935
  * Add Built-Using for BFD  (+ iberty, sframe)
  * Fix VCS  repo to science-team and push to salsa

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Jan 2024 14:22:10 +0000

lfortran (0.30.0-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 24 Jan 2024 19:48:26 +0000

lfortran (0.30.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1057266)
  * Patch to ensure we don't include statically linked zlib

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Jan 2024 16:10:25 +0000

=== debian/control ===
Source: lfortran
Section: devel
Priority: optional
Standards-Version: 4.6.2
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends:  debhelper-compat (= 13),
 cmake,
 pandoc,
 libfmt-dev,
 llvm-16-dev,
 libjsoncpp-dev,
 binutils-dev,
 libiberty-dev,
 libzstd-dev,
 libcurl4-gnutls-dev,
 rapidjson-dev,
 xeus-dev, xeus-zmq-dev,
 zlib1g-dev
Homepage: https://lfortran.org
Vcs-Browser: https://salsa.debian.org/science-team/lfortran.git
Vcs-Git: https://salsa.debian.org/science-team/lfortran.git

Package: lfortran
Architecture: any
Provides: fortran-compiler, lfortran-mod-0
Built-Using: ${Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}, liblfortran-runtime0 ( = ${binary:Version}), 
 clang-16,
 liblfortran-dev ( = ${binary:Version}),
Description: Modern interactive LLVM-based Fortran compiler
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.

Package: liblfortran-runtime0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime libraries for the lfortran compiler
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.
 .
 This provides the lfortran runtime libraries.

Package: liblfortran-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, liblfortran-runtime0 (= ${binary:Version})
Description: flang library - Development package.
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.
 .
 This provides the static libraries and development files.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

BUILDDIR=debian/build
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# The magic debhelper  rule
%:
	dh $@ --builddirectory=$(BUILDDIR) --buildsystem=cmake

override_dh_auto_clean:
	dh_clean
	rm -fr $(BUILDDIR)

# -DWITH_XEUS=yes for Jupyter kernel support
# not currently compiling ?

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)
	dh_auto_configure --  \
		-DCMAKE_BUILD_TYPE=Debug \
		-DWITH_JSON=yes \
		-DWITH_FMT=yes \
		-DWITH_BFD=yes	\
		-DWITH_LLVM=yes \
		-DLLVM_DIR=/usr/lib/llvm-16/cmake \
		-DWITH_RUNTIME_STACKTRACE=yes \
		-DWITH_STACKTRACE=yes \
		-DWITH_KOKKOS=no \
		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-0


override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="`dpkg-query -f'$${source:Package} (= $${source:Version}), ' -W binutils-dev libiberty-dev`"

override_dh_auto_test:
	@echo Bypass tests on this build

## lfortran 0.35.0

=== debian/changelog ===
lfortran (0.35.0-1) unstable; urgency=medium

  * New upstream release
  * Don't use DWZ; fails on s390x
  * Build with DWARFDUMP=yes, KOKKOS=yes
  * Ship /usr/share/lfortran/*
  * Depend on python3 for scripts

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Apr 2024 18:44:14 +0100

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,7 @@
 Built-Using: ${Built-Using}
 Depends: ${misc:Depends}, ${shlibs:Depends}, liblfortran-runtime0 ( = ${binary:Version}), 
  clang-16,
+ python3:any | python3-minimal:any,
  liblfortran-dev ( = ${binary:Version}),
 Description: Modern interactive LLVM-based Fortran compiler
  LFortran is a modern open-source (BSD licensed) interactive Fortran compiler

## lfortran 0.36.0

=== src/libasr/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
     codegen/asr_to_cpp.cpp
     codegen/asr_to_c.cpp
     codegen/asr_to_julia.cpp
+    codegen/asr_to_python.cpp
     codegen/asr_to_fortran.cpp
     codegen/asr_to_py.cpp
     codegen/x86_assembler.cpp
@@ -30,9 +31,11 @@
 
     pass/nested_vars.cpp
     pass/where.cpp
+    pass/function_call_in_declaration.cpp
     pass/param_to_const.cpp
     pass/do_loops.cpp
     pass/for_all.cpp
+    pass/while_else.cpp
     pass/global_stmts.cpp
     pass/select_case.cpp
     pass/init_expr.cpp
@@ -51,6 +54,7 @@
     pass/div_to_mul.cpp
     pass/replace_symbolic.cpp
     pass/intrinsic_function.cpp
+    pass/intrinsic_subroutine.cpp
     pass/fma.cpp
     pass/loop_vectorise.cpp
     pass/sign_from_value.cpp
@@ -112,3 +116,10 @@
 if (WITH_LLVM)
     target_link_libraries(asr p::llvm)
 endif()
+
+# Install the dwarf_convert.py and dat_convert.py
+install(
+    FILES dwarf_convert.py dat_convert.py
+    PERMISSIONS OWNER_EXECUTE OWNER_READ
+    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/lfortran
+)

=== src/runtime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(lfortran_unif_runtime C Fortran)

set(LFORTRAN_NESTED_BUILD no
    CACHE BOOL "Whether we are being called from the LFortran build system")

if(NOT LFORTRAN_NESTED_BUILD)
    add_subdirectory(legacy)
endif()

# See the TODO in the installation step below
set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR})
include_directories(${CMAKE_Fortran_MODULE_DIRECTORY})

macro(lfortran_compile_runtime name dir)
  add_library(${name} OBJECT ${dir}/${name}.f90)
  target_compile_options(${name} PUBLIC "--backend=cpp")
  set_target_properties(${name} PROPERTIES
    POSITION_INDEPENDENT_CODE False
    Fortran_PREPROCESS False)

  if(ARGN)
    add_dependencies(${name} ${ARGN})
  endif()
endmacro(lfortran_compile_runtime)

lfortran_compile_runtime(lfortran_intrinsic_builtin builtin)
lfortran_compile_runtime(lfortran_intrinsic_iso_fortran_env pure)

lfortran_compile_runtime(lfortran_intrinsic_custom custom)

lfortran_compile_runtime(lfortran_intrinsic_ieee_arithmetic pure)
add_dependencies(lfortran_intrinsic_ieee_arithmetic lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_iso_c_binding pure)
add_dependencies(lfortran_intrinsic_iso_c_binding lfortran_intrinsic_builtin)

lfortran_compile_runtime(lfortran_intrinsic_string pure)
add_dependencies(lfortran_intrinsic_string lfortran_intrinsic_builtin)
add_dependencies(lfortran_intrinsic_string lfortran_intrinsic_iso_fortran_env)

lfortran_compile_runtime(lfortran_intrinsic_math impure)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_iso_c_binding)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_builtin)
add_dependencies(lfortran_intrinsic_math lfortran_intrinsic_iso_fortran_env)

# Ideally this should be a target based install, not file based:
# install(DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/ DESTINATION ${CMAKE_INSTALL_LIBDIR})
# but for historical reasons get_runtime_library_dir() looks under "/../../runtime"
# during tests.
# TODO: Change get_runtime_library_dir() to "/../../modfiles" for tests
install(
  FILES
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_builtin.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_custom.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_iso_fortran_env.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_ieee_arithmetic.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_iso_c_binding.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_math.mod
  ${CMAKE_Fortran_MODULE_DIRECTORY}/lfortran_intrinsic_string.mod
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

=== debian/changelog ===
lfortran (0.36.0-1) unstable; urgency=medium

  * New upstream release
  * Set Debian Science Maint. as maintainer
  * Standards-Version: 4.7.0; no changes required
  * Include full BSD license as lintian hints
  * Don't depend on python:minimal

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Jun 2024 17:31:56 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: lfortran
 Section: devel
 Priority: optional
-Standards-Version: 4.6.2
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Standards-Version: 4.7.0
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends:  debhelper-compat (= 13),
  cmake,
  pandoc,
@@ -26,7 +27,7 @@
 Built-Using: ${Built-Using}
 Depends: ${misc:Depends}, ${shlibs:Depends}, liblfortran-runtime0 ( = ${binary:Version}), 
  clang-16,
- python3:any | python3-minimal:any,
+ python3:any ,
  liblfortran-dev ( = ${binary:Version}),
 Description: Modern interactive LLVM-based Fortran compiler
  LFortran is a modern open-source (BSD licensed) interactive Fortran compiler

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,7 @@
 	mkdir -p $(BUILDDIR)
 	dh_auto_configure --  \
 		-DCMAKE_BUILD_TYPE=Debug \
+		-DWITH_DWARFDUMP=yes  \
 		-DWITH_JSON=yes \
 		-DWITH_FMT=yes \
 		-DWITH_BFD=yes	\
@@ -27,7 +28,7 @@
 		-DLLVM_DIR=/usr/lib/llvm-16/cmake \
 		-DWITH_RUNTIME_STACKTRACE=yes \
 		-DWITH_STACKTRACE=yes \
-		-DWITH_KOKKOS=no \
+		-DWITH_KOKKOS=yes \
 		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-0
 
 
@@ -36,3 +37,6 @@
 
 override_dh_auto_test:
 	@echo Bypass tests on this build
+
+override_dh_dwz:
+	@echo "DWZ fails on .debug_attr sections in some archs; don't use"

## lfortran 0.40.0

=== debian/changelog ===
lfortran (0.40.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 Nov 2024 05:02:25 +0000

## lfortran 0.42.0

=== debian/changelog ===
lfortran (0.42.0-1) unstable; urgency=medium

  * New upstream release
  * Move to llvm-19. Closes: #1081244

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Nov 2024 19:42:19 +0000

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  cmake,
  pandoc,
  libfmt-dev,
- llvm-16-dev,
+ llvm-19-dev,
  libjsoncpp-dev,
  binutils-dev,
  libiberty-dev,
@@ -26,7 +26,7 @@
 Provides: fortran-compiler, lfortran-mod-0
 Built-Using: ${Built-Using}
 Depends: ${misc:Depends}, ${shlibs:Depends}, liblfortran-runtime0 ( = ${binary:Version}), 
- clang-16,
+ clang-19,
  python3:any ,
  liblfortran-dev ( = ${binary:Version}),
 Description: Modern interactive LLVM-based Fortran compiler

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 		-DWITH_FMT=yes \
 		-DWITH_BFD=yes	\
 		-DWITH_LLVM=yes \
-		-DLLVM_DIR=/usr/lib/llvm-16/cmake \
+		-DLLVM_DIR=/usr/lib/llvm-19/cmake \
 		-DWITH_RUNTIME_STACKTRACE=yes \
 		-DWITH_STACKTRACE=yes \
 		-DWITH_KOKKOS=yes \
